{% extends 'main_app/base.html' %}

{% load static %}

{% block specific_css %}
    <link href="https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.6/css/select2.min.css" rel="stylesheet"/>
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
    <link rel="stylesheet" type="text/css" href="{% static 'assignments/css/form.css' %}">
{% endblock specific_css %}

{% block content %}
    {# Django Tempus Dominus assets are included in `{{ form.media }}` #}
    {{ form.media }}

    <div class="container">
        <div class="row my-5">
            <div class="col-1"></div>
            <div class="col-10">
                <h1>New Assignment</h1>
                {% if form.errors %}
                    {% for field in form %}
                        {% for error in field.errors %}
                            <div class="alert alert-danger">
                                <strong>{{ error|escape }}</strong>
                            </div>
                        {% endfor %}
                    {% endfor %}
                    {% for error in form.non_field_errors %}
                        <div class="alert alert-danger">
                            <strong>{{ error|escape }}</strong>
                        </div>
                    {% endfor %}
                {% endif %}
                <form method="post" enctype="multipart/form-data" onsubmit="clearStorage()">
                    {% csrf_token %}
                    <div class="form-group">
                        <label for="id_title"><strong>Assignment Title <span
                                class="required_field">*</span></strong></label>
                        {{ form.title }}
                    </div>
                    <div class="form-group">
                        <label for="id_allowed_languages"><strong>Allowed Languages<span
                                class="required_field">*</span></strong></label>
                        {{ form.allowed_languages }}
                    </div>
                    <div class="form-group">
                        <label for="id_tags"><strong>Tags</strong></label>
                        {{ form.tags }}
                        <a href="" data-toggle="modal" data-target="#createTagModal">+ Create new tag</a>
                    </div>
                    <div class="form-group">
                        <label for="id_cleanup_script"><strong>Cleanup Script</strong></label>
                        {{ form.cleanup_script }}
                    </div>
                    <div class="form-group">
                        <label for="id_statement"><strong>Statement</strong></label>
                        {{ form.statement }}
                        <small id="statement_help" class="form-text text-muted">PDFs are accepted.</small>
                    </div>
                    <div class="form-group">
                        <label for="id_source"><strong>Source</strong></label>
                        {{ form.source }}
                        <small id="source_help" class="form-text text-muted">The packed source code for the problem statement.</small>
                    </div>
                    <div class="form-group">
                        <label for="id_course"><strong>Course <span class="required_field">*</span></strong></label>
                        {{ form.course }}
                    </div>
                    <div class="form-group">
                        <label for="id_deadline"><strong>Deadline</strong></label>
                        {{ form.deadline }}
                    </div>
                    <div class="form-group">
                        <label for="id_period"><strong>Period</strong></label>
                        {{ form.period }}
                    </div>
                    <div class="form-group">
                        <label for="id_published"><strong>Is Published</strong></label>
                        {{ form.published }}
                    </div>
                    <div class="form-group">
                        <label for="id_tests"><strong>Test Cases</strong></label>
                        {{ form.tests }}
                        <small id="tests_help" class="form-text text-muted">All .csv, .yml, .yaml and .json files are
                            accepted. The format on this file can be found <a href="" data-toggle="modal"
                                                                              data-target=".bd-tutorial-modal-lg">here</a>.
                        </small>
                    </div>
                    <button type="submit" class="btn btn-primary">Submit</button>
                </form>

                <div class="modal fade" id="createTagModal" tabindex="-1" role="dialog"
                     aria-labelledby="createTagModalLabel" aria-hidden="true">
                    <div class="modal-dialog" role="document">
                        <div class="modal-content">
                            <div class="modal-header">
                                <h5 class="modal-title" id="createTagModalLabel">New Tag</h5>
                                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                                    <span aria-hidden="true">&times;</span>
                                </button>
                            </div>
                            <div class="modal-body">
                                <iframe id="tagForm" src="{% url "create_tag" %}" class="w-100 border-0"
                                        height="200px"></iframe>
                            </div>
                        </div>
                    </div>
                </div>

                <div class="modal fade bd-tutorial-modal-lg" tabindex="-1" role="dialog"
                     aria-labelledby="myLargeModalLabel"
                     aria-hidden="true">
                    <div class="modal-dialog modal-lg">
                        <div class="modal-content">
                            <div class="modal-header">
                                <h5 class="modal-title" id="myLargeModalLabel">Accepted Test Files</h5>
                                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                                    <span aria-hidden="true">&times;</span>
                                </button>
                            </div>
                            <div class="modal-body">
                                <h4>Format of the File</h4>
                                <p>A file must contain an array of dictionaries with 4 parameters:</p>
                                <ul>
                                    <li>An Input that must be a string.</li>
                                    <li>An Output that must be a string.</li>
                                    <li>A Comment that must be a string.</li>
                                    <li>And a Test Type must be a string from the following: "public", "semi_private",
                                        "private". (If this field is not one of the previous strings the test will be
                                        taken as private).
                                    </li>
                                </ul>
                                <p>
                                    The Input and Output fields are very self explanatory, the comment is a string that
                                    explains the test and will show with the feedback of the test. Some examples are
                                    "Basic Tests", "Big Numbers Test", "Large Arrays", etc.

                                    The Test Type strinf indicates the type of feedback a test will have when a code
                                    sample
                                    is tested. The string "public" represent Public Tests, "semi_private" represents
                                    Semi-Private Tests and "private"
                                    are Private Tests:
                                </p>

                                <ul>
                                    <li>Public Tests: The feedback for this type of tests consists of a boolean
                                        indicating
                                        if it passed the test or not, the input, the expected output, the resulting
                                        output
                                        and the comment.
                                    </li>
                                    <li>Semi-Private Tests: The feedback for this type of tests consists of just the
                                        boolean
                                        and the comment.
                                    </li>
                                    <li>Semi-Private Tests: These tests aren't shown in the feedback.</li>
                                </ul>

                                <p>
                                    The specifications shown before are only for the student feedback, for the assistant
                                    and
                                    teacher feedback every test wiil be shown as if it were a public test.
                                </p>

                                <h4>File Examples</h4>
                                <h5>Json</h5>
                                <a href="{% static 'file_samples/example_test_file.json' %}"
                                   download="example_test_file.json"><i class="fa fa-file"></i> Download Example
                                    File</a>
                                <pre><code>[
    {
        "Input": "[1,2,3,4]",
        "Output": "1",
        "Comment": "A Comment",
        "Test Type": "public"
    },
    {
        "Input": "[5,6,7,8]",
        "Output": "0",
        "Comment": "Another Coment",
        "Test Type": "private"
    }
]

</code></pre>
                                <h5>Csv</h5>
                                <a href="{% static 'file_samples/example_test_file.csv' %}"
                                   download="example_test_file.csv"><i class="fa fa-file"></i> Download Example File</a>
                                <pre><code>Input,Output,Comment,Test Type
"[1,2,3,4]",1,A Comment,public
"[5,6,7,8]",0,Another Coment,private
</code></pre>
                                <h5>Yml and Yaml</h5>
                                <a href="{% static 'file_samples/example_test_file.yaml' %}"
                                   download="example_test_file.yaml"><i class="fa fa-file"></i> Download Example
                                    File</a>
                                <pre><code>---
- Input: "[1,2,3,4]"
  Output: '1'
  Comment: A Comment
  Test Type: public
- Input: "[5,6,7,8]"
  Output: '0'
  Comment: Another Coment
  Test Type: private
</code></pre>
                            </div>
                            <div class="modal-footer">
                                <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            <div class="col-1"></div>
        </div>
    </div>
{% endblock content %}

{% block specific_js %}
    <script src="https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.6/js/select2.min.js"></script>
    <script type="text/javascript">
        $(document).ready(function () {
            $("#id_tags").select2();
            $("#id_allowed_languages").select2();

            // reload to get newly created tags
            $('#createTagModal').on('hidden.bs.modal', function () {
                window.location = window.location;
            })
        });

        let saveStorage = true;

        // save field values
        window.onbeforeunload = () => {
            if (saveStorage) {
                sessionStorage.setItem("title", $('#id_title').val());
                sessionStorage.setItem("allowed_languages", $('#id_allowed_languages').val());
                sessionStorage.setItem("cleanup_script", $('#id_cleanup_script').val());
                sessionStorage.setItem("tags", $('#id_tags').val());
                sessionStorage.setItem("course", $('#id_course').val());
                sessionStorage.setItem("deadline", $('#id_deadline').val());
                sessionStorage.setItem("period", $('#id_period').val());
                sessionStorage.setItem("published", $('#id_published').val());
            }
        };

        // restore field values
        window.onload = () => {
            let title = sessionStorage.getItem("title");
            if (title !== null) $('#id_title').val(title);
            let allowed_languages = sessionStorage.getItem("allowed_languages").split(",");
            if (allowed_languages !== null) $('#id_allowed_languages').val(allowed_languages).change();
            let cleanup_script = sessionStorage.getItem("cleanup_script").split(",");
            if (cleanup_script !== null) $('#id_cleanup_script').val(cleanup_script).change();
            let tags = sessionStorage.getItem("tags").split(",");
            if (tags !== null) $('#id_tags').val(tags).change();
            let course = sessionStorage.getItem("course");
            if (course !== null) $('#id_course').val(course);
            let deadline = sessionStorage.getItem("deadline");
            if (deadline !== null) $('#id_deadline').val(deadline);
            let period = sessionStorage.getItem("period");
            if (period !== null) $('#id_period').val(period);
            let published = sessionStorage.getItem("published");
            if (published !== null) $('#id_published').val(published);
        };

        function clearStorage() {
            saveStorage = false;
            sessionStorage.clear();
        }
    </script>

    <script>
        $("#create_assignments_light").css("font-weight", "Bold");
    </script>

{% endblock specific_js %}
